#ifndef _Xwms_h
#define _Xwms_h

#include <stdio.h>

#include <X11/IntrinsicP.h>

/* define the Xwms version */
#define XWMS_VERSION         1L

/* define the Xwms extension record */
typedef struct
{
   XtPointer next_extension;
   XrmQuark record_type;
   long version;
   Cardinal record_size;

   /* field to save the class part initialize method */
   Boolean trace_class_part_initialize;

   /* private core class method fields */
   XtProc class_initialize;
   XtWidgetClassProc class_part_initialize;
   XtInitProc initialize;
   XtArgsProc initialize_hook;
   XtRealizeProc realize;
   XtWidgetProc destroy;
   XtWidgetProc resize;
   XtExposeProc expose;
   XtSetValuesFunc set_values;
   XtArgsFunc set_values_hook;
   XtAlmostProc set_values_almost;
   XtArgsProc get_values_hook;
   XtAcceptFocusProc accept_focus;
   XtGeometryHandler query_geometry;
   XtStringProc display_accelerator;

} WidgetStatisticsExtensionRec, *WidgetStatisticsExtension;

/* Method masks */
#define NoMethodMask                0L
#define ClassInitializeMask         (1L << 0)
#define ClassPartInitializeMask     (1L << 1)
#define InitializeMask              (1L << 2)
#define InitializeHookMask          (1L << 3)
#define RealizeMask                 (1L << 4)
#define DestroyMask                 (1L << 5)
#define ResizeMask                  (1L << 6)
#define ExposeMask                  (1L << 7)
#define SetValuesMask               (1L << 8)
#define SetValuesHookMask           (1L << 9)
#define SetValuesAlmostMask         (1L << 10)
#define GetValuesHookMask           (1L << 11)
#define AcceptFocusMask             (1L << 12)
#define QueryGeometryMask           (1L << 13)
#define DisplayAcceleratorMask      (1L << 14)
#define ChangeManagedMask           (1L << 15)
#define AllMethodsMask              ((long) 0xffffffff)

/* value used to indicate that methods should be switched after
   widget class initialization */
#define _XwmsInheritMethodLater     (-1)

#endif /* _Xwms_h */
