#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/DialogS.h>

#include "wms_core.h"

static void xmDialogShell_class_initialize ();
static void xmDialogShell_class_part_initialize ();
static void xmDialogShell_initialize ();
static void xmDialogShell_initialize_hook ();
static void xmDialogShell_realize ();
static void xmDialogShell_destroy ();
static void xmDialogShell_resize ();
static void xmDialogShell_expose ();
static Boolean xmDialogShell_set_values ();
static Boolean xmDialogShell_set_values_hook ();
static void xmDialogShell_set_values_almost ();
static void xmDialogShell_get_values_hook ();
static Boolean xmDialogShell_accept_focus ();
static XtGeometryResult xmDialogShell_query_geometry ();
static void xmDialogShell_display_accelerator ();

void _Xwms_init_xmDialogShell (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmDialogShellWidgetClass;
   coreMethods->class_initialize = xmDialogShell_class_initialize;
   coreMethods->class_part_initialize = 
      xmDialogShell_class_part_initialize;
   coreMethods->initialize = xmDialogShell_initialize;
   coreMethods->initialize_hook = xmDialogShell_initialize_hook;
   coreMethods->realize = xmDialogShell_realize;
   coreMethods->destroy = xmDialogShell_destroy;
   coreMethods->resize = xmDialogShell_resize;
   coreMethods->expose = xmDialogShell_expose;
   coreMethods->set_values = xmDialogShell_set_values;
   coreMethods->set_values_hook = xmDialogShell_set_values_hook;
   coreMethods->set_values_almost = xmDialogShell_set_values_almost;
   coreMethods->get_values_hook = xmDialogShell_get_values_hook;
   coreMethods->accept_focus = xmDialogShell_accept_focus;
   coreMethods->query_geometry = xmDialogShell_query_geometry;
   coreMethods->display_accelerator = xmDialogShell_display_accelerator;
}
 
void xmDialogShell_class_initialize ()
{
   _Xwms_class_initialize (xmDialogShellWidgetClass);
}

void xmDialogShell_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmDialogShellWidgetClass);
} 

void xmDialogShell_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmDialogShellWidgetClass);
}

void xmDialogShell_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmDialogShellWidgetClass);
}

void xmDialogShell_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmDialogShellWidgetClass);
}

void xmDialogShell_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmDialogShellWidgetClass);
}

void xmDialogShell_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmDialogShellWidgetClass);
}

void xmDialogShell_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmDialogShellWidgetClass);
}

Boolean xmDialogShell_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmDialogShellWidgetClass));
}

Boolean xmDialogShell_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmDialogShellWidgetClass));
}

void xmDialogShell_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmDialogShellWidgetClass);
}

void xmDialogShell_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmDialogShellWidgetClass);
}

Boolean xmDialogShell_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmDialogShellWidgetClass);
}

XtGeometryResult xmDialogShell_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmDialogShellWidgetClass));
}

void xmDialogShell_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmDialogShellWidgetClass);
}
