#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/DrawingA.h>

#include "wms_core.h"

static void xmDrawingArea_class_initialize ();
static void xmDrawingArea_class_part_initialize ();
static void xmDrawingArea_initialize ();
static void xmDrawingArea_initialize_hook ();
static void xmDrawingArea_realize ();
static void xmDrawingArea_destroy ();
static void xmDrawingArea_resize ();
static void xmDrawingArea_expose ();
static Boolean xmDrawingArea_set_values ();
static Boolean xmDrawingArea_set_values_hook ();
static void xmDrawingArea_set_values_almost ();
static void xmDrawingArea_get_values_hook ();
static Boolean xmDrawingArea_accept_focus ();
static XtGeometryResult xmDrawingArea_query_geometry ();
static void xmDrawingArea_display_accelerator ();

void _Xwms_init_xmDrawingArea (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmDrawingAreaWidgetClass;
   coreMethods->class_initialize = xmDrawingArea_class_initialize;
   coreMethods->class_part_initialize = 
      xmDrawingArea_class_part_initialize;
   coreMethods->initialize = xmDrawingArea_initialize;
   coreMethods->initialize_hook = xmDrawingArea_initialize_hook;
   coreMethods->realize = xmDrawingArea_realize;
   coreMethods->destroy = xmDrawingArea_destroy;
   coreMethods->resize = xmDrawingArea_resize;
   coreMethods->expose = xmDrawingArea_expose;
   coreMethods->set_values = xmDrawingArea_set_values;
   coreMethods->set_values_hook = xmDrawingArea_set_values_hook;
   coreMethods->set_values_almost = xmDrawingArea_set_values_almost;
   coreMethods->get_values_hook = xmDrawingArea_get_values_hook;
   coreMethods->accept_focus = xmDrawingArea_accept_focus;
   coreMethods->query_geometry = xmDrawingArea_query_geometry;
   coreMethods->display_accelerator = xmDrawingArea_display_accelerator;
}
 
void xmDrawingArea_class_initialize ()
{
   _Xwms_class_initialize (xmDrawingAreaWidgetClass);
}

void xmDrawingArea_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmDrawingAreaWidgetClass);
} 

void xmDrawingArea_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmDrawingAreaWidgetClass);
}

void xmDrawingArea_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmDrawingAreaWidgetClass);
}

void xmDrawingArea_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmDrawingAreaWidgetClass);
}

void xmDrawingArea_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmDrawingAreaWidgetClass);
}

void xmDrawingArea_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmDrawingAreaWidgetClass);
}

void xmDrawingArea_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmDrawingAreaWidgetClass);
}

Boolean xmDrawingArea_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmDrawingAreaWidgetClass));
}

Boolean xmDrawingArea_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmDrawingAreaWidgetClass));
}

void xmDrawingArea_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmDrawingAreaWidgetClass);
}

void xmDrawingArea_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmDrawingAreaWidgetClass);
}

Boolean xmDrawingArea_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmDrawingAreaWidgetClass);
}

XtGeometryResult xmDrawingArea_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmDrawingAreaWidgetClass));
}

void xmDrawingArea_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmDrawingAreaWidgetClass);
}
