#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/DrawnB.h>

#include "wms_core.h"

static void xmDrawnButton_class_initialize ();
static void xmDrawnButton_class_part_initialize ();
static void xmDrawnButton_initialize ();
static void xmDrawnButton_initialize_hook ();
static void xmDrawnButton_realize ();
static void xmDrawnButton_destroy ();
static void xmDrawnButton_resize ();
static void xmDrawnButton_expose ();
static Boolean xmDrawnButton_set_values ();
static Boolean xmDrawnButton_set_values_hook ();
static void xmDrawnButton_set_values_almost ();
static void xmDrawnButton_get_values_hook ();
static Boolean xmDrawnButton_accept_focus ();
static XtGeometryResult xmDrawnButton_query_geometry ();
static void xmDrawnButton_display_accelerator ();

void _Xwms_init_xmDrawnButton (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmDrawnButtonWidgetClass;
   coreMethods->class_initialize = xmDrawnButton_class_initialize;
   coreMethods->class_part_initialize = 
      xmDrawnButton_class_part_initialize;
   coreMethods->initialize = xmDrawnButton_initialize;
   coreMethods->initialize_hook = xmDrawnButton_initialize_hook;
   coreMethods->realize = xmDrawnButton_realize;
   coreMethods->destroy = xmDrawnButton_destroy;
   coreMethods->resize = xmDrawnButton_resize;
   coreMethods->expose = xmDrawnButton_expose;
   coreMethods->set_values = xmDrawnButton_set_values;
   coreMethods->set_values_hook = xmDrawnButton_set_values_hook;
   coreMethods->set_values_almost = xmDrawnButton_set_values_almost;
   coreMethods->get_values_hook = xmDrawnButton_get_values_hook;
   coreMethods->accept_focus = xmDrawnButton_accept_focus;
   coreMethods->query_geometry = xmDrawnButton_query_geometry;
   coreMethods->display_accelerator = xmDrawnButton_display_accelerator;
}
 
void xmDrawnButton_class_initialize ()
{
   _Xwms_class_initialize (xmDrawnButtonWidgetClass);
}

void xmDrawnButton_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmDrawnButtonWidgetClass);
} 

void xmDrawnButton_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmDrawnButtonWidgetClass);
}

void xmDrawnButton_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmDrawnButtonWidgetClass);
}

void xmDrawnButton_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmDrawnButtonWidgetClass);
}

void xmDrawnButton_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmDrawnButtonWidgetClass);
}

void xmDrawnButton_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmDrawnButtonWidgetClass);
}

void xmDrawnButton_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmDrawnButtonWidgetClass);
}

Boolean xmDrawnButton_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmDrawnButtonWidgetClass));
}

Boolean xmDrawnButton_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmDrawnButtonWidgetClass));
}

void xmDrawnButton_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmDrawnButtonWidgetClass);
}

void xmDrawnButton_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmDrawnButtonWidgetClass);
}

Boolean xmDrawnButton_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmDrawnButtonWidgetClass);
}

XtGeometryResult xmDrawnButton_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmDrawnButtonWidgetClass));
}

void xmDrawnButton_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmDrawnButtonWidgetClass);
}
