#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/MessageB.h>

#include "wms_core.h"

static void xmMessageBox_class_initialize ();
static void xmMessageBox_class_part_initialize ();
static void xmMessageBox_initialize ();
static void xmMessageBox_initialize_hook ();
static void xmMessageBox_realize ();
static void xmMessageBox_destroy ();
static void xmMessageBox_resize ();
static void xmMessageBox_expose ();
static Boolean xmMessageBox_set_values ();
static Boolean xmMessageBox_set_values_hook ();
static void xmMessageBox_set_values_almost ();
static void xmMessageBox_get_values_hook ();
static Boolean xmMessageBox_accept_focus ();
static XtGeometryResult xmMessageBox_query_geometry ();
static void xmMessageBox_display_accelerator ();

void _Xwms_init_xmMessageBox (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmMessageBoxWidgetClass;
   coreMethods->class_initialize = xmMessageBox_class_initialize;
   coreMethods->class_part_initialize = 
      xmMessageBox_class_part_initialize;
   coreMethods->initialize = xmMessageBox_initialize;
   coreMethods->initialize_hook = xmMessageBox_initialize_hook;
   coreMethods->realize = xmMessageBox_realize;
   coreMethods->destroy = xmMessageBox_destroy;
   coreMethods->resize = xmMessageBox_resize;
   coreMethods->expose = xmMessageBox_expose;
   coreMethods->set_values = xmMessageBox_set_values;
   coreMethods->set_values_hook = xmMessageBox_set_values_hook;
   coreMethods->set_values_almost = xmMessageBox_set_values_almost;
   coreMethods->get_values_hook = xmMessageBox_get_values_hook;
   coreMethods->accept_focus = xmMessageBox_accept_focus;
   coreMethods->query_geometry = xmMessageBox_query_geometry;
   coreMethods->display_accelerator = xmMessageBox_display_accelerator;
}
 
void xmMessageBox_class_initialize ()
{
   _Xwms_class_initialize (xmMessageBoxWidgetClass);
}

void xmMessageBox_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmMessageBoxWidgetClass);
} 

void xmMessageBox_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmMessageBoxWidgetClass);
}

void xmMessageBox_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmMessageBoxWidgetClass);
}

void xmMessageBox_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmMessageBoxWidgetClass);
}

void xmMessageBox_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmMessageBoxWidgetClass);
}

void xmMessageBox_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmMessageBoxWidgetClass);
}

void xmMessageBox_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmMessageBoxWidgetClass);
}

Boolean xmMessageBox_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmMessageBoxWidgetClass));
}

Boolean xmMessageBox_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmMessageBoxWidgetClass));
}

void xmMessageBox_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmMessageBoxWidgetClass);
}

void xmMessageBox_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmMessageBoxWidgetClass);
}

Boolean xmMessageBox_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmMessageBoxWidgetClass);
}

XtGeometryResult xmMessageBox_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmMessageBoxWidgetClass));
}

void xmMessageBox_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmMessageBoxWidgetClass);
}
