#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/RowColumn.h>

#include "wms_core.h"

static void xmRowColumn_class_initialize ();
static void xmRowColumn_class_part_initialize ();
static void xmRowColumn_initialize ();
static void xmRowColumn_initialize_hook ();
static void xmRowColumn_realize ();
static void xmRowColumn_destroy ();
static void xmRowColumn_resize ();
static void xmRowColumn_expose ();
static Boolean xmRowColumn_set_values ();
static Boolean xmRowColumn_set_values_hook ();
static void xmRowColumn_set_values_almost ();
static void xmRowColumn_get_values_hook ();
static Boolean xmRowColumn_accept_focus ();
static XtGeometryResult xmRowColumn_query_geometry ();
static void xmRowColumn_display_accelerator ();

void _Xwms_init_xmRowColumn (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmRowColumnWidgetClass;
   coreMethods->class_initialize = xmRowColumn_class_initialize;
   coreMethods->class_part_initialize = 
      xmRowColumn_class_part_initialize;
   coreMethods->initialize = xmRowColumn_initialize;
   coreMethods->initialize_hook = xmRowColumn_initialize_hook;
   coreMethods->realize = xmRowColumn_realize;
   coreMethods->destroy = xmRowColumn_destroy;
   coreMethods->resize = xmRowColumn_resize;
   coreMethods->expose = xmRowColumn_expose;
   coreMethods->set_values = xmRowColumn_set_values;
   coreMethods->set_values_hook = xmRowColumn_set_values_hook;
   coreMethods->set_values_almost = xmRowColumn_set_values_almost;
   coreMethods->get_values_hook = xmRowColumn_get_values_hook;
   coreMethods->accept_focus = xmRowColumn_accept_focus;
   coreMethods->query_geometry = xmRowColumn_query_geometry;
   coreMethods->display_accelerator = xmRowColumn_display_accelerator;
}
 
void xmRowColumn_class_initialize ()
{
   _Xwms_class_initialize (xmRowColumnWidgetClass);
}

void xmRowColumn_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmRowColumnWidgetClass);
} 

void xmRowColumn_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmRowColumnWidgetClass);
}

void xmRowColumn_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmRowColumnWidgetClass);
}

void xmRowColumn_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmRowColumnWidgetClass);
}

void xmRowColumn_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmRowColumnWidgetClass);
}

void xmRowColumn_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmRowColumnWidgetClass);
}

void xmRowColumn_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmRowColumnWidgetClass);
}

Boolean xmRowColumn_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmRowColumnWidgetClass));
}

Boolean xmRowColumn_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmRowColumnWidgetClass));
}

void xmRowColumn_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmRowColumnWidgetClass);
}

void xmRowColumn_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmRowColumnWidgetClass);
}

Boolean xmRowColumn_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmRowColumnWidgetClass);
}

XtGeometryResult xmRowColumn_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmRowColumnWidgetClass));
}

void xmRowColumn_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmRowColumnWidgetClass);
}
