#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/SelectioB.h>

#include "wms_core.h"

static void xmSelectionBox_class_initialize ();
static void xmSelectionBox_class_part_initialize ();
static void xmSelectionBox_initialize ();
static void xmSelectionBox_initialize_hook ();
static void xmSelectionBox_realize ();
static void xmSelectionBox_destroy ();
static void xmSelectionBox_resize ();
static void xmSelectionBox_expose ();
static Boolean xmSelectionBox_set_values ();
static Boolean xmSelectionBox_set_values_hook ();
static void xmSelectionBox_set_values_almost ();
static void xmSelectionBox_get_values_hook ();
static Boolean xmSelectionBox_accept_focus ();
static XtGeometryResult xmSelectionBox_query_geometry ();
static void xmSelectionBox_display_accelerator ();

void _Xwms_init_xmSelectionBox (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmSelectionBoxWidgetClass;
   coreMethods->class_initialize = xmSelectionBox_class_initialize;
   coreMethods->class_part_initialize = 
      xmSelectionBox_class_part_initialize;
   coreMethods->initialize = xmSelectionBox_initialize;
   coreMethods->initialize_hook = xmSelectionBox_initialize_hook;
   coreMethods->realize = xmSelectionBox_realize;
   coreMethods->destroy = xmSelectionBox_destroy;
   coreMethods->resize = xmSelectionBox_resize;
   coreMethods->expose = xmSelectionBox_expose;
   coreMethods->set_values = xmSelectionBox_set_values;
   coreMethods->set_values_hook = xmSelectionBox_set_values_hook;
   coreMethods->set_values_almost = xmSelectionBox_set_values_almost;
   coreMethods->get_values_hook = xmSelectionBox_get_values_hook;
   coreMethods->accept_focus = xmSelectionBox_accept_focus;
   coreMethods->query_geometry = xmSelectionBox_query_geometry;
   coreMethods->display_accelerator = xmSelectionBox_display_accelerator;
}
 
void xmSelectionBox_class_initialize ()
{
   _Xwms_class_initialize (xmSelectionBoxWidgetClass);
}

void xmSelectionBox_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmSelectionBoxWidgetClass);
} 

void xmSelectionBox_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmSelectionBoxWidgetClass);
}

void xmSelectionBox_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmSelectionBoxWidgetClass);
}

void xmSelectionBox_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmSelectionBoxWidgetClass);
}

void xmSelectionBox_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmSelectionBoxWidgetClass);
}

void xmSelectionBox_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmSelectionBoxWidgetClass);
}

void xmSelectionBox_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmSelectionBoxWidgetClass);
}

Boolean xmSelectionBox_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmSelectionBoxWidgetClass));
}

Boolean xmSelectionBox_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmSelectionBoxWidgetClass));
}

void xmSelectionBox_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmSelectionBoxWidgetClass);
}

void xmSelectionBox_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmSelectionBoxWidgetClass);
}

Boolean xmSelectionBox_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmSelectionBoxWidgetClass);
}

XtGeometryResult xmSelectionBox_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmSelectionBoxWidgetClass));
}

void xmSelectionBox_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmSelectionBoxWidgetClass);
}
