#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/Text.h>

#include "wms_core.h"

static void xmText_class_initialize ();
static void xmText_class_part_initialize ();
static void xmText_initialize ();
static void xmText_initialize_hook ();
static void xmText_realize ();
static void xmText_destroy ();
static void xmText_resize ();
static void xmText_expose ();
static Boolean xmText_set_values ();
static Boolean xmText_set_values_hook ();
static void xmText_set_values_almost ();
static void xmText_get_values_hook ();
static Boolean xmText_accept_focus ();
static XtGeometryResult xmText_query_geometry ();
static void xmText_display_accelerator ();

void _Xwms_init_xmText (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmTextWidgetClass;
   coreMethods->class_initialize = xmText_class_initialize;
   coreMethods->class_part_initialize = 
      xmText_class_part_initialize;
   coreMethods->initialize = xmText_initialize;
   coreMethods->initialize_hook = xmText_initialize_hook;
   coreMethods->realize = xmText_realize;
   coreMethods->destroy = xmText_destroy;
   coreMethods->resize = xmText_resize;
   coreMethods->expose = xmText_expose;
   coreMethods->set_values = xmText_set_values;
   coreMethods->set_values_hook = xmText_set_values_hook;
   coreMethods->set_values_almost = xmText_set_values_almost;
   coreMethods->get_values_hook = xmText_get_values_hook;
   coreMethods->accept_focus = xmText_accept_focus;
   coreMethods->query_geometry = xmText_query_geometry;
   coreMethods->display_accelerator = xmText_display_accelerator;
}
 
void xmText_class_initialize ()
{
   _Xwms_class_initialize (xmTextWidgetClass);
}

void xmText_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmTextWidgetClass);
} 

void xmText_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmTextWidgetClass);
}

void xmText_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmTextWidgetClass);
}

void xmText_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmTextWidgetClass);
}

void xmText_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmTextWidgetClass);
}

void xmText_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmTextWidgetClass);
}

void xmText_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmTextWidgetClass);
}

Boolean xmText_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmTextWidgetClass));
}

Boolean xmText_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmTextWidgetClass));
}

void xmText_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmTextWidgetClass);
}

void xmText_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmTextWidgetClass);
}

Boolean xmText_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmTextWidgetClass);
}

XtGeometryResult xmText_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmTextWidgetClass));
}

void xmText_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmTextWidgetClass);
}
