#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/TextF.h>

#include "wms_core.h"

static void xmTextField_class_initialize ();
static void xmTextField_class_part_initialize ();
static void xmTextField_initialize ();
static void xmTextField_initialize_hook ();
static void xmTextField_realize ();
static void xmTextField_destroy ();
static void xmTextField_resize ();
static void xmTextField_expose ();
static Boolean xmTextField_set_values ();
static Boolean xmTextField_set_values_hook ();
static void xmTextField_set_values_almost ();
static void xmTextField_get_values_hook ();
static Boolean xmTextField_accept_focus ();
static XtGeometryResult xmTextField_query_geometry ();
static void xmTextField_display_accelerator ();

void _Xwms_init_xmTextField (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmTextFieldWidgetClass;
   coreMethods->class_initialize = xmTextField_class_initialize;
   coreMethods->class_part_initialize = 
      xmTextField_class_part_initialize;
   coreMethods->initialize = xmTextField_initialize;
   coreMethods->initialize_hook = xmTextField_initialize_hook;
   coreMethods->realize = xmTextField_realize;
   coreMethods->destroy = xmTextField_destroy;
   coreMethods->resize = xmTextField_resize;
   coreMethods->expose = xmTextField_expose;
   coreMethods->set_values = xmTextField_set_values;
   coreMethods->set_values_hook = xmTextField_set_values_hook;
   coreMethods->set_values_almost = xmTextField_set_values_almost;
   coreMethods->get_values_hook = xmTextField_get_values_hook;
   coreMethods->accept_focus = xmTextField_accept_focus;
   coreMethods->query_geometry = xmTextField_query_geometry;
   coreMethods->display_accelerator = xmTextField_display_accelerator;
}
 
void xmTextField_class_initialize ()
{
   _Xwms_class_initialize (xmTextFieldWidgetClass);
}

void xmTextField_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmTextFieldWidgetClass);
} 

void xmTextField_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmTextFieldWidgetClass);
}

void xmTextField_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmTextFieldWidgetClass);
}

void xmTextField_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmTextFieldWidgetClass);
}

void xmTextField_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmTextFieldWidgetClass);
}

void xmTextField_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmTextFieldWidgetClass);
}

void xmTextField_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmTextFieldWidgetClass);
}

Boolean xmTextField_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmTextFieldWidgetClass));
}

Boolean xmTextField_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmTextFieldWidgetClass));
}

void xmTextField_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmTextFieldWidgetClass);
}

void xmTextField_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmTextFieldWidgetClass);
}

Boolean xmTextField_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmTextFieldWidgetClass);
}

XtGeometryResult xmTextField_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmTextFieldWidgetClass));
}

void xmTextField_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmTextFieldWidgetClass);
}
