#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <Xm/ToggleB.h>

#include "wms_core.h"

static void xmToggleButton_class_initialize ();
static void xmToggleButton_class_part_initialize ();
static void xmToggleButton_initialize ();
static void xmToggleButton_initialize_hook ();
static void xmToggleButton_realize ();
static void xmToggleButton_destroy ();
static void xmToggleButton_resize ();
static void xmToggleButton_expose ();
static Boolean xmToggleButton_set_values ();
static Boolean xmToggleButton_set_values_hook ();
static void xmToggleButton_set_values_almost ();
static void xmToggleButton_get_values_hook ();
static Boolean xmToggleButton_accept_focus ();
static XtGeometryResult xmToggleButton_query_geometry ();
static void xmToggleButton_display_accelerator ();

void _Xwms_init_xmToggleButton (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = xmToggleButtonWidgetClass;
   coreMethods->class_initialize = xmToggleButton_class_initialize;
   coreMethods->class_part_initialize = 
      xmToggleButton_class_part_initialize;
   coreMethods->initialize = xmToggleButton_initialize;
   coreMethods->initialize_hook = xmToggleButton_initialize_hook;
   coreMethods->realize = xmToggleButton_realize;
   coreMethods->destroy = xmToggleButton_destroy;
   coreMethods->resize = xmToggleButton_resize;
   coreMethods->expose = xmToggleButton_expose;
   coreMethods->set_values = xmToggleButton_set_values;
   coreMethods->set_values_hook = xmToggleButton_set_values_hook;
   coreMethods->set_values_almost = xmToggleButton_set_values_almost;
   coreMethods->get_values_hook = xmToggleButton_get_values_hook;
   coreMethods->accept_focus = xmToggleButton_accept_focus;
   coreMethods->query_geometry = xmToggleButton_query_geometry;
   coreMethods->display_accelerator = xmToggleButton_display_accelerator;
}
 
void xmToggleButton_class_initialize ()
{
   _Xwms_class_initialize (xmToggleButtonWidgetClass);
}

void xmToggleButton_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, xmToggleButtonWidgetClass);
} 

void xmToggleButton_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, xmToggleButtonWidgetClass);
}

void xmToggleButton_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, xmToggleButtonWidgetClass);
}

void xmToggleButton_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, xmToggleButtonWidgetClass);
}

void xmToggleButton_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, xmToggleButtonWidgetClass);
}

void xmToggleButton_resize (w)
   Widget w;
{
   _Xwms_resize (w, xmToggleButtonWidgetClass);
}

void xmToggleButton_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, xmToggleButtonWidgetClass);
}

Boolean xmToggleButton_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      xmToggleButtonWidgetClass));
}

Boolean xmToggleButton_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      xmToggleButtonWidgetClass));
}

void xmToggleButton_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      xmToggleButtonWidgetClass);
}

void xmToggleButton_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, xmToggleButtonWidgetClass);
}

Boolean xmToggleButton_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, xmToggleButtonWidgetClass);
}

XtGeometryResult xmToggleButton_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      xmToggleButtonWidgetClass));
}

void xmToggleButton_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, xmToggleButtonWidgetClass);
}
