#include <X11/Intrinsic.h>

#include "wms.h"
#include "wms_core.h"

void _XwmsInstallClassInitialize (class_methods, widget_class, extension)
   CoreMethods class_methods;
   WidgetClass widget_class;
   WidgetStatisticsExtension extension;
{
   if (widget_class->core_class.class_initialize != NULL)
   { /* Begin statistics collection for the Class Initialize method */
      extension->class_initialize = widget_class->core_class.class_initialize;
      widget_class->core_class.class_initialize = class_methods->class_initialize;

#ifdef DEBUG
      printf ("Begin class initialize method tracing for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
   }
#ifdef DEBUG
   else
      printf ("There is no class initialize method for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
}

void _XwmsInstallClassPartInitialize (class_methods, widget_class, extension, 
      trace)
   CoreMethods class_methods;
   WidgetClass widget_class;
   WidgetStatisticsExtension extension;
{
   if (widget_class->core_class.class_part_initialize != NULL)
   { /* Begin statistics collection for the Class Part Initialize method */
      extension->class_part_initialize = 
         widget_class->core_class.class_part_initialize;
      widget_class->core_class.class_part_initialize = 
         class_methods->class_part_initialize;

#ifdef DEBUG
      printf ("Begin class_part_initialize method tracing for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
   }
#ifdef DEBUG
   else
      printf ("There is no class_part_initialize method for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
}

void _XwmsSpecialInstallClassPartInitialize (class_methods, widget_class, extension, 
      trace)
   CoreMethods class_methods;
   WidgetClass widget_class;
   WidgetStatisticsExtension extension;
{
   extension->class_part_initialize = 
      widget_class->core_class.class_part_initialize;

   widget_class->core_class.class_part_initialize = 
      class_methods->class_part_initialize;
}

void _XwmsInstallInitialize (class_methods, widget_class, extension)
   CoreMethods class_methods;
   WidgetClass widget_class;
   WidgetStatisticsExtension extension;
{
   if (widget_class->core_class.initialize != NULL)
   { /* Begin statistics collection for the Initialize method */
      extension->initialize = widget_class->core_class.initialize;
      widget_class->core_class.initialize = class_methods->initialize;

#ifdef DEBUG
      printf ("Begin initialize method tracing for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
   }
#ifdef DEBUG
   else
      printf ("There is no initialize method for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
}

void _XwmsInstallInitializeHook (class_methods, widget_class, extension)
   CoreMethods class_methods;
   WidgetClass widget_class;
   WidgetStatisticsExtension extension;
{
   if (widget_class->core_class.initialize_hook != NULL)
   { /* Begin statistics collection for the initialize_hook method */
      extension->initialize_hook = widget_class->core_class.initialize_hook;
      widget_class->core_class.initialize_hook = class_methods->initialize_hook;

#ifdef DEBUG
      printf ("Begin initialize_hook method tracing for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
   }
#ifdef DEBUG
   else
      printf ("There is no initialize_hook method for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
}

void _XwmsInstallRealize (class_methods, widget_class, extension)
   CoreMethods class_methods;
   WidgetClass widget_class;
   WidgetStatisticsExtension extension;
{
   if (widget_class->core_class.realize != NULL)
   { /* Begin statistics collection for the Realize method */
      extension->realize = widget_class->core_class.realize;
      widget_class->core_class.realize = class_methods->realize;

#ifdef DEBUG
      printf ("Begin realize method tracing for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
   }
#ifdef DEBUG
   else
      printf ("There is no realize method (ERROR) for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
}

void _XwmsInstallDestroy (class_methods, widget_class, extension)
   CoreMethods class_methods;
   WidgetClass widget_class;
   WidgetStatisticsExtension extension;
{
   if (widget_class->core_class.destroy != NULL)
   { /* Begin statistics collection for the Destroy method */
      extension->destroy = widget_class->core_class.destroy;
      widget_class->core_class.destroy = class_methods->destroy;

#ifdef DEBUG
      printf ("Begin destroy method tracing for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
   }
#ifdef DEBUG
   else
      printf ("There is no destroy method for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
}

void _XwmsInstallResize (class_methods, widget_class, extension)
   CoreMethods class_methods;
   WidgetClass widget_class;
   WidgetStatisticsExtension extension;
{
   if (widget_class->core_class.resize != NULL)
   { /* Begin statistics collection for the Resize method */
      extension->resize = widget_class->core_class.resize;
      widget_class->core_class.resize = class_methods->resize;

#ifdef DEBUG
      printf ("Begin resize method tracing for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
   }
#ifdef DEBUG
   else
      printf ("There is no resize method for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
}

void _XwmsInstallExpose (class_methods, widget_class, extension)
   CoreMethods class_methods;
   WidgetClass widget_class;
   WidgetStatisticsExtension extension;
{
   if (widget_class->core_class.expose != NULL)
   { /* Begin statistics collection for the Expose method */
      extension->expose = widget_class->core_class.expose;
      widget_class->core_class.expose = class_methods->expose;

#ifdef DEBUG
      printf ("Begin expose method tracing for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
   }
#ifdef DEBUG
   else
      printf ("There is no expose method for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
}

void _XwmsInstallSetValues (class_methods, widget_class, extension)
   CoreMethods class_methods;
   WidgetClass widget_class;
   WidgetStatisticsExtension extension;
{
   if (widget_class->core_class.set_values != NULL)
   { /* Begin statistics collection for the SetValues method */
      extension->set_values = widget_class->core_class.set_values;
      widget_class->core_class.set_values = class_methods->set_values;

#ifdef DEBUG
      printf ("Begin set_values method tracing for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
   }
#ifdef DEBUG
   else
      printf ("There is no set_values method for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
}

void _XwmsInstallSetValuesHook (class_methods, widget_class, extension)
   CoreMethods class_methods;
   WidgetClass widget_class;
   WidgetStatisticsExtension extension;
{
   if (widget_class->core_class.set_values_hook != NULL)
   { /* Begin statistics collection for the set_values_hook method */
      extension->set_values_hook = widget_class->core_class.set_values_hook;
      widget_class->core_class.set_values_hook = class_methods->set_values_hook;

#ifdef DEBUG
      printf ("Begin set_values_hook method tracing for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
   }
#ifdef DEBUG
   else
      printf ("There is no set_values_hook method for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
}

void _XwmsInstallSetValuesAlmost (class_methods, widget_class, extension)
   CoreMethods class_methods;
   WidgetClass widget_class;
   WidgetStatisticsExtension extension;
{
   if (widget_class->core_class.set_values_almost != NULL)
   { /* Begin statistics collection for the set_values_almost method */
      extension->set_values_almost = widget_class->core_class.set_values_almost;
      widget_class->core_class.set_values_almost = class_methods->set_values_almost;

#ifdef DEBUG
      printf ("Begin set_values_almost method tracing for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
   }
#ifdef DEBUG
   else
      printf ("There is no set_values_almost method (ERROR) for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
}

void _XwmsInstallGetValuesHook (class_methods, widget_class, extension)
   CoreMethods class_methods;
   WidgetClass widget_class;
   WidgetStatisticsExtension extension;
{
   if (widget_class->core_class.get_values_hook != NULL)
   { /* Begin statistics collection for the get_values_hook method */
      extension->get_values_hook = widget_class->core_class.get_values_hook;
      widget_class->core_class.get_values_hook = class_methods->get_values_hook;

#ifdef DEBUG
      printf ("Begin get_values_hook method tracing for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
   }
#ifdef DEBUG
   else
      printf ("There is no get_values_hook method for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
}

void _XwmsInstallAcceptFocus (class_methods, widget_class, extension)
   CoreMethods class_methods;
   WidgetClass widget_class;
   WidgetStatisticsExtension extension;
{
   if (widget_class->core_class.accept_focus != NULL)
   { /* Begin statistics collection for the accept_focus method */
      extension->accept_focus = widget_class->core_class.accept_focus;
      widget_class->core_class.accept_focus = class_methods->accept_focus;

#ifdef DEBUG
      printf ("Begin accept_focus method tracing for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
   }
#ifdef DEBUG
   else
      printf ("There is no accept_focus method for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
}

void _XwmsInstallQueryGeometry (class_methods, widget_class, extension)
   CoreMethods class_methods;
   WidgetClass widget_class;
   WidgetStatisticsExtension extension;
{
   if (widget_class->core_class.query_geometry != NULL)
   { /* Begin statistics collection for the Resize method */
      extension->query_geometry = widget_class->core_class.query_geometry;
      widget_class->core_class.query_geometry = class_methods->query_geometry;

#ifdef DEBUG
      printf ("Begin query_gemoetry method tracing for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
   }
#ifdef DEBUG
   else
      printf ("There is no query_geometry method for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
}

void _XwmsInstallDisplayAccelerator (class_methods, widget_class, extension)
   CoreMethods class_methods;
   WidgetClass widget_class;
   WidgetStatisticsExtension extension;
{
   if (widget_class->core_class.display_accelerator != NULL)
   { /* Begin statistics collection for the accept_focus method */
      extension->display_accelerator = 
         widget_class->core_class.display_accelerator;
      widget_class->core_class.display_accelerator = 
         class_methods->display_accelerator;

#ifdef DEBUG
      printf ("Begin display_accelerator method tracing for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
   }
#ifdef DEBUG
   else
      printf ("There is no display_accelerator method for widget class <%s>\n",
         widget_class->core_class.class_name);
#endif
}
