#include <X11/Intrinsic.h>
#include <X11/IntrinsicP.h>
#include <X11/Shell.h>

#include "wms_core.h"

static void xtApplicationShell_class_initialize ();
static void xtApplicationShell_class_part_initialize ();
static void xtApplicationShell_initialize ();
static void xtApplicationShell_initialize_hook ();
static void xtApplicationShell_realize ();
static void xtApplicationShell_destroy ();
static void xtApplicationShell_resize ();
static void xtApplicationShell_expose ();
static Boolean xtApplicationShell_set_values ();
static Boolean xtApplicationShell_set_values_hook ();
static void xtApplicationShell_set_values_almost ();
static void xtApplicationShell_get_values_hook ();
static Boolean xtApplicationShell_accept_focus ();
static XtGeometryResult xtApplicationShell_query_geometry ();
static void xtApplicationShell_display_accelerator ();

void _Xwms_init_xtApplicationShell (coreMethods)
   CoreMethods coreMethods;
{
   /* initialize label fields */
   coreMethods->wc = applicationShellWidgetClass;
   coreMethods->class_initialize = xtApplicationShell_class_initialize;
   coreMethods->class_part_initialize = 
      xtApplicationShell_class_part_initialize;
   coreMethods->initialize = xtApplicationShell_initialize;
   coreMethods->initialize_hook = xtApplicationShell_initialize_hook;
   coreMethods->realize = xtApplicationShell_realize;
   coreMethods->destroy = xtApplicationShell_destroy;
   coreMethods->resize = xtApplicationShell_resize;
   coreMethods->expose = xtApplicationShell_expose;
   coreMethods->set_values = xtApplicationShell_set_values;
   coreMethods->set_values_hook = xtApplicationShell_set_values_hook;
   coreMethods->set_values_almost = xtApplicationShell_set_values_almost;
   coreMethods->get_values_hook = xtApplicationShell_get_values_hook;
   coreMethods->accept_focus = xtApplicationShell_accept_focus;
   coreMethods->query_geometry = xtApplicationShell_query_geometry;
   coreMethods->display_accelerator = xtApplicationShell_display_accelerator;
}
 
void xtApplicationShell_class_initialize ()
{
   _Xwms_class_initialize (applicationShellWidgetClass);
}

void xtApplicationShell_class_part_initialize (wc)
   WidgetClass wc;
{
   _Xwms_class_part_initialize (wc, applicationShellWidgetClass);
} 

void xtApplicationShell_initialize (request, new, args, num_args)
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize (request, new, args, num_args, applicationShellWidgetClass);
}

void xtApplicationShell_initialize_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_initialize_hook (w, args, num_args, applicationShellWidgetClass);
}

void xtApplicationShell_realize (w, mask, attr)
   Widget w;
   XtValueMask *mask;
   XSetWindowAttributes *attr;
{
   _Xwms_realize (w, mask, attr, applicationShellWidgetClass);
}

void xtApplicationShell_destroy (w)
   Widget w;
{
   _Xwms_destroy (w, applicationShellWidgetClass);
}

void xtApplicationShell_resize (w)
   Widget w;
{
   _Xwms_resize (w, applicationShellWidgetClass);
}

void xtApplicationShell_expose (w, event, region)
   Widget w;
   XEvent *event;
   Region region;
{
   _Xwms_expose (w, event, region, applicationShellWidgetClass);
}

Boolean xtApplicationShell_set_values (old, request, new, args, num_args)
   Widget old;
   Widget request;
   Widget new;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values (old, request, new, args, num_args, 
      applicationShellWidgetClass));
}

Boolean xtApplicationShell_set_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   return (_Xwms_set_values_hook (w, args, num_args, 
      applicationShellWidgetClass));
}

void xtApplicationShell_set_values_almost (w, new_widget_return, request, reply)
   Widget w;
   Widget new_widget_return;
   XtWidgetGeometry *request;
   XtWidgetGeometry *reply;
{
   _Xwms_set_values_almost (w, new_widget_return, request, reply, 
      applicationShellWidgetClass);
}

void xtApplicationShell_get_values_hook (w, args, num_args)
   Widget w;
   ArgList args;
   Cardinal *num_args;
{
   _Xwms_get_values_hook (w, args, num_args, applicationShellWidgetClass);
}

Boolean xtApplicationShell_accept_focus (w, time)
   Widget w;
   Time *time;
{
   _Xwms_accept_focus (w, time, applicationShellWidgetClass);
}

XtGeometryResult xtApplicationShell_query_geometry (w, request, geometry_return)
   Widget w;
   XtWidgetGeometry request;
   XtWidgetGeometry geometry_return;
{
   return (_Xwms_query_geometry (w, request, geometry_return, 
      applicationShellWidgetClass));
}

void xtApplicationShell_display_accelerator (w, string)
   Widget w;
   String string;
{
   _Xwms_display_accelerator (w, string, applicationShellWidgetClass);
}
