#include <stdio.h>
#include "wmsstats.h"

void usage ()
{
   printf ("usage: wmsdump [filename]\n");
   exit (1);
}

main (argc, argv)
int argc;
char *argv[];
{
   FILE *fp;
   WidgetStatisticsDataRec datarec;
   char *filename;
   char *defaultname = "wms.data";

   if (argc > 2)
      usage ();

   if (argc == 1)
      filename = defaultname;
   else
      filename = argv[1];

   fp = fopen (filename, "r");
   if (fp == (FILE *) NULL)
   {
      printf ("wmsdump: Could not open file %s\n", filename);
      exit (1);
   }

   while (fread (&datarec, sizeof (datarec), 1, fp) == 1)
   {
      printf ("%s.%s for widget %s.%s: %d secs %d nanosecs\n",
         datarec.method_string, datarec.method_class, datarec.widget_name,
         datarec.widget_class, datarec.secs, datarec.nanosecs);
   }
}
